
/** XHConn - Simple XMLHTTP Interface - bfults@gmail.com - 2005-04-08        **
 ** Code licensed under Creative Commons Attribution-ShareAlike License      **
 ** http://creativecommons.org/licenses/by-sa/2.0/                           **/
var nDebug = 0;

function XHConn() {
  var xmlhttp, bComplete = false;
  try             { xmlhttp = new ActiveXObject("Msxml2.XMLHTTP"); }
  catch (e) { try { xmlhttp = new ActiveXObject("Microsoft.XMLHTTP"); }
  catch (e) { try { xmlhttp = new XMLHttpRequest(); }
  catch (e)       { xmlhttp = false; }}}
  if (!xmlhttp) {
    alert("XHConn failed");
    return null;
    } // if

  this.connect = function(sURL, fnDone) {
    if (!xmlhttp) {
      alert("XHConn failed");
      return false;
      } // if
      
    bComplete = false;

    try {
      xmlhttp.open("GET", sURL, true);

      xmlhttp.onreadystatechange = function() {
        if ((xmlhttp.readyState == 4) && (xmlhttp.status == 200) && !bComplete) {
          bComplete = true;
          fnDone(xmlhttp);
          } // if
        }; // xmlhttp.onreadystatechange

      xmlhttp.send("");
      } 
    catch(z) {
      return false; 
      } 
    
    return true;
    }; // this.connect

  return this;
  } // XHConn

function loadXMLDoc(dname) {
if (window.XMLHttpRequest)
  {
  xhttp=new XMLHttpRequest();
  }
else
  {
  xhttp=new ActiveXObject("Microsoft.XMLHTTP");
  }
xhttp.open("GET",dname,false);
xhttp.send();
return xhttp.responseXML;
} // loadXMLDoc

//
// simonjo      : generic code for Mozilla, Firefox, IExplorer, WM5-PIE
//
// strRspList   : <rsp-list>   = <r-rsp>   *[';' <r-rsp>]
//                <r-rsp>      = <rsp>     *[':' <rsp>]
// strStateList : <state-list> = <r-state> *[';' <r-state>]
//                <r-state>    = <state>   *[':' <state>]
//
function ohcAjaxHandleResponse(strRspList, strStateList, dyImg) {
  var arrRRsp, strRRsp, arrRsp, strRsp, arrRState, strRState;
  
  // split rsp-list and state-list 
  arrRRsp   = strRspList.split(";");
  arrRState = strStateList.split(";");
  
  if (strRspList.indexOf("err") > -1) {
    alert("iControl error occured:req='" + strStateList + "',rsp='" + strRspList + "'");
    } // if
  else if (document.images && (arrRRsp.length == arrRState.length)) {
    // walk all images
    for (i = 0; i < document.images.length; i++) {
        
      // walk each <r-state>
      for (j = 0; j < arrRState.length; j++) {
          
        // only update matching images
        if (document.images.item(i).id == arrRState[j]) {
          // handle <r-rsp> = <rsp> *[:<rsp>]
          strRRsp   = arrRRsp[j];
          arrRsp    = strRRsp.split(":");
          strRState = arrRState[j];

          for (yImg = 0, k = 0; k < arrRsp.length; k++) {
            strRsp = arrRsp[k];
            
            if (strRState.indexOf("dim") == 0) {
              // handle dimmer, only first <state>
              yImg = parseInt((parseInt(arrRsp[k]) + 31) / 32);
//            alert("ohcAjaxHandleResponse:dimmer=" + strRState + ",yImg=" + yImg);
              break;
              } // if
            else {
              // handle all <state>s
              yImg = parseInt(parseInt(yImg * 2) + parseInt(arrRsp[k]));
              } // else
                              
            } // for arrRsp.length
              
          // apply image scaling
          yImg = parseInt(yImg * dyImg);
          document.images.item(i).style.backgroundPosition = "0px -" + yImg + "px";
          } // if
        } // for arrState.length
      } // for document.images.length
    } // else if document.images

} // ohcAjaxHandleResponse

//
// strEvent  : <ccmd>
// nDelay    : delay in ms between event and state fetching
// strState  : <state-list> = <r-state> *[; <r-state>]
//             <r-state>    = <state>   *[: <state>]
// dyImg     : vertical image scaling for state reporting
//
function ohcAjaxSendCmd(strEvent, nDelay, strState, dyImg) {
  if (nDebug & 1)
    alert("ohcAjaxSendCmd: strEvent=" + strEvent + ",nDelay=" + nDelay + ",strState=" + strState + ",dyImg=" + dyImg);
  
  var fnRsp = function(oXML) {
    ohcAjaxHandleResponse(oXML.responseText, strState, dyImg);
    } // fnRsp

  var myConn = new XHConn();
  if (!myConn) {
    alert("XMLHTTP not available, try a newer/better browser.");
    return false; 
    } // if
    
  myConn.connect("/icontrol.dll?terse&ccmd=" + strEvent + "&wait=" + nDelay + "&ccmd=" + strState + "&dummy=" + Math.random(), fnRsp);
  } // ohcAjaxSendCmd

